/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the MessageContactUrl type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MessageContactUrl{}

// MessageContactUrl struct for MessageContactUrl
type MessageContactUrl struct {
	Url string `json:"url"`
	Type *string `json:"type,omitempty"`
}

// NewMessageContactUrl instantiates a new MessageContactUrl object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMessageContactUrl(url string) *MessageContactUrl {
	this := MessageContactUrl{}
	this.Url = url
	return &this
}

// NewMessageContactUrlWithDefaults instantiates a new MessageContactUrl object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMessageContactUrlWithDefaults() *MessageContactUrl {
	this := MessageContactUrl{}
	return &this
}

// GetUrl returns the Url field value
func (o *MessageContactUrl) GetUrl() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Url
}

// GetUrlOk returns a tuple with the Url field value
// and a boolean to check if the value has been set.
func (o *MessageContactUrl) GetUrlOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Url, true
}

// SetUrl sets field value
func (o *MessageContactUrl) SetUrl(v string) {
	o.Url = v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *MessageContactUrl) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageContactUrl) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *MessageContactUrl) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *MessageContactUrl) SetType(v string) {
	o.Type = &v
}

func (o MessageContactUrl) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MessageContactUrl) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["url"] = o.Url
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	return toSerialize, nil
}

type NullableMessageContactUrl struct {
	value *MessageContactUrl
	isSet bool
}

func (v NullableMessageContactUrl) Get() *MessageContactUrl {
	return v.value
}

func (v *NullableMessageContactUrl) Set(val *MessageContactUrl) {
	v.value = val
	v.isSet = true
}

func (v NullableMessageContactUrl) IsSet() bool {
	return v.isSet
}

func (v *NullableMessageContactUrl) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMessageContactUrl(val *MessageContactUrl) *NullableMessageContactUrl {
	return &NullableMessageContactUrl{value: val, isSet: true}
}

func (v NullableMessageContactUrl) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMessageContactUrl) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


